local mod = ...



-- Prefab -----------------------------------------------------------------------------------------------------------
mod:registerAssetId("models/InvisibleHouse1.fbx/Prefab/EmptyPart", "PREFAB_IH_EMPTY")
mod:registerAssetId("models/InvisibleHouse1.fbx/Prefab/Level1Density1Part", "PREFAB_IH_HOUSE1")
mod:registerAssetId("models/InvisibleHouse1.fbx/Prefab/Level1Density2Part", "PREFAB_IH_HOUSE2")
mod:registerAssetId("models/InvisibleHouse1.fbx/Prefab/Level2Density1Part", "PREFAB_IH_HOUSE3")
mod:registerAssetId("models/InvisibleHouse1.fbx/Prefab/Level2Density2Part", "PREFAB_IH_HOUSE4")



-- Grounding -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/InvisibleHouse1.fbx/Prefab/EmptyPart", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/InvisibleHouse1.fbx/Prefab/Level1Density1Part", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/InvisibleHouse1.fbx/Prefab/Level1Density2Part", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/InvisibleHouse1.fbx/Prefab/Level2Density1Part", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/InvisibleHouse1.fbx/Prefab/Level2Density2Part", {DataType = "COMP_GROUNDED"})



-- Building Asset Processor ---------------------------------------------------------------------------------
mod:registerAssetProcessor("models/InvisibleHouse1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- -- Building: Housing -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "BUILDING", 
-- 	Id = "BUILDING_IH_HOUSE",
-- 	Name = "BUILDING_IH_HOUSE_NAME",
-- 	Description = "BUILDING_IH_HOUSE_DESC",
-- 	BuildingType = "DECORATION",
--     AssetCoreBuildingPart = "BUILDING_PART_MONUMENT_POLE",
-- 	BuildingPartSetList = {
-- 		{
-- 			Name = "BUILDING_SET_IH_HOUSE1_NAME",
-- 			BuildingPartList = { 
-- 				"BUILDING_PART_HOUSING_SERF_DENSITY_1",
-- 				"BUILDING_PART_HOUSING_SERF_DENSITY_2",
-- 				"BUILDING_PART_HOUSING_CITIZEN_DENSITY_1",
-- 				"BUILDING_PART_HOUSING_CITIZEN_DENSITY_2",
-- 			}
-- 		},
-- })



-- Building Part: Inivisible House 1 -------------------------------------------------------------------------------------

-- Part
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_IH_HOUSE1",
	Name = "BUILDING_PART_IH_HOUSE1_NAME", 
	Description = "BUILDING_PART_IH_HOUSE1_DESC", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_IH_HOUSE1"
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {2, 2}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		}
	}
})


-- Assemblage
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_IH_HOUSE1A",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
        CoreRandomBuildingPartList = { "PREFAB_IH_EMPTY" },
        MandatoryBuildingPartList = {
            { BuildingPart = "BUILDING_PART_IH_HOUSE1" }
        }
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {2, 2}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		}
	}
})


-- Override
mod:override({
    Id = "BUILDING_PART_HOUSING_SERF_DENSITY_1",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
            "BUILDING_PART_IH_HOUSE1A",
        }
    },
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {2, 2}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		}
	}
})




-- Building Part: Inivisible House 2 -------------------------------------------------------------------------------------

-- Part
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_IH_HOUSE2",
	Name = "BUILDING_PART_IH_HOUSE2_NAME", 
	Description = "BUILDING_PART_IH_HOUSE2_DESC", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_IH_HOUSE2"
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {2, 2}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		}
	}
})


-- Assemblage
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_IH_HOUSE2A",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
        CoreRandomBuildingPartList = { "PREFAB_IH_EMPTY" },
        MandatoryBuildingPartList = {
            { BuildingPart = "BUILDING_PART_IH_HOUSE2" }
        }
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {2, 2}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		}
	}
})


-- Override
mod:override({
    Id = "BUILDING_PART_HOUSING_SERF_DENSITY_2",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
            "BUILDING_PART_IH_HOUSE2A",
        }
    },
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {2, 2}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		}
	}
})




-- Building Part: Inivisible House 3 -------------------------------------------------------------------------------------

-- Part
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_IH_HOUSE3",
	Name = "BUILDING_PART_IH_HOUSE3_NAME", 
	Description = "BUILDING_PART_IH_HOUSE3_DESC", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_IH_HOUSE3"
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {2, 2}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		}
	}
})


-- Assemblage
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_IH_HOUSE3A",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
        CoreRandomBuildingPartList = { "PREFAB_IH_EMPTY" },
        MandatoryBuildingPartList = {
            { BuildingPart = "BUILDING_PART_IH_HOUSE3" }
        }
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {2, 2}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		}
	}
})


-- Override
mod:override({
    Id = "BUILDING_PART_HOUSING_CITIZEN_DENSITY_1",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
            "BUILDING_PART_IH_HOUSE3A",
        }
    },
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {2, 2}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		}
	}
})




-- Building Part: Inivisible House 4 -------------------------------------------------------------------------------------

-- Part
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_IH_HOUSE4",
	Name = "BUILDING_PART_IH_HOUSE4_NAME", 
	Description = "BUILDING_PART_IH_HOUSE4_DESC", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_IH_HOUSE4"
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {2, 2}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		}
	}
})


-- Assemblage
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_IH_HOUSE4A",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
        CoreRandomBuildingPartList = { "PREFAB_IH_EMPTY" },
        MandatoryBuildingPartList = {
            { BuildingPart = "BUILDING_PART_IH_HOUSE4" }
        }
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {2, 2}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		}
	}
})


-- Override
mod:override({
    Id = "BUILDING_PART_HOUSING_CITIZEN_DENSITY_2",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
            "BUILDING_PART_IH_HOUSE4A",
        }
    },
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {2, 2}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		}
	}
})



-- Implement all changes to main Balancing asset -------------------------------------------------------------------------------------
mod:override({
    Id = "DEFAULT_BALANCING",
    BuildingCostOverrideList = {
        Action = "APPEND", "BUILDING_PART_COST_LIST_OVERRIDE_IH"
    }
})



-- Change the native buildings controlled by Building Part Cost List, by creating a cost list override and appending to the default balancing ID -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_PART_COST_LIST",
    Id = "BUILDING_PART_COST_LIST_OVERRIDE_IH",
    BuildingPartCostList = {

		-- House Serf Level 1
		{
			BuildingPart = "BUILDING_PART_HOUSING_SERF_DENSITY_1",
			BuildingPartCost = {
				RessourcesNeeded = {
				}
			}
		}, 

		-- House Serf Level 2
		{
			BuildingPart = "BUILDING_PART_HOUSING_SERF_DENSITY_2",
			BuildingPartCost = {
				RessourcesNeeded = {
				}
			}
		}, 

		-- House Commoner Level 1
		{
			BuildingPart = "BUILDING_PART_HOUSING_CITIZEN_DENSITY_1",
			BuildingPartCost = {
				RessourcesNeeded = {
				}
			}
		}, 

		-- House Commoner Level 2
		{
			BuildingPart = "BUILDING_PART_HOUSING_CITIZEN_DENSITY_2",
			BuildingPartCost = {
				RessourcesNeeded = {
				}
			}
        }, 
    
    }
})